class Error(Exception):
    """Base class for all bytewax errors."""

    pass


class LoginError(Error):
    """Error to return when no bytewax token is available"""

    def __init__(self, message):
        self.message = message


class Unavailable(Error):
    """Error to return when the bytewax api is unavailable"""

    def __init__(self, message):
        self.message = message


class SwarmNotFound(Error):
    """Error returned when the specified swarm is not found"""

    def __init__(self, message):
        self.message = message


class SwarmCreationError(Error):
    """Error returned when creating a swarm was unsuccessful"""

    def __init__(self, message):
        self.message = message


class SwarmDeletionError(Error):
    """Error returned when creating a swarm was unsuccessful"""

    def __init__(self, message):
        self.message = message


class ResourceNotFound(Error):
    """Error returned when resource (swarm or bee) is not found"""

    def __init__(self, message):
        self.message = message


class GatewayTimeoutError(Error):
    """Error returned when gRPC calls time out"""

    def __init__(self, message):
        self.message = message
