from prometheus_client import Counter, Histogram

messages_published = Counter(
    "messages_published_count",
    "Total amount of messages published by bee",
    ["bee", "swarm"],
)

messages_responded = Counter(
    "messages_responded_count",
    "Total amount of messages responded by bee",
    ["bee", "swarm"],
)

messages_received = Counter(
    "messages_received_count",
    "Total amount of messages received by bee",
    ["bee", "swarm", "input_bee_name", "error"],
)

bee_processing_time = Histogram(
    "bee_processing_time",
    "Amount of time (in seconds) bee has taken to process single message (including deserialization)",
    ["bee", "swarm", "input_bee_name"],
)
