import sys
import os
import structlog
import shutil

from importlib.util import spec_from_file_location, module_from_spec
from bytewax.swarm import Swarm, bee_func
from bytewax.swarm.utils import load_bee_file

import nbformat
from nbconvert.exporters import PythonExporter

from bytewax.swarm import Swarm, bee_func

log = structlog.get_logger()

bee_file = sys.argv[1]
bee_function = sys.argv[2]
try:
    base_bee_working_directory = sys.argv[3]
except IndexError:
    base_bee_working_directory = ""

if os.path.isdir(base_bee_working_directory):
    bee_working_directory = base_bee_working_directory + "/user-files"
    shutil.copytree(os.getcwd(), bee_working_directory, dirs_exist_ok=True, ignore_dangling_symlinks=True, symlinks=True)
    os.chdir(bee_working_directory)
else:
    log.warning(f"Working directory '{base_bee_working_directory}' not found. Using default directory `{os.getcwd()}`")

if bee_file.endswith(".ipynb"):
    with open(bee_file, "r") as f:
        nb = nbformat.read(f, nbformat.NO_CONVERT)
    python_exporter = PythonExporter()
    nb_py = python_exporter.from_filename(bee_file)

    notebook_file = os.path.basename(bee_file)
    notebook_dir = os.path.dirname(bee_file)

    temp_bee_filename = notebook_file + "-converted.py"
    bee_file = os.path.join(notebook_dir, temp_bee_filename)
    with open(bee_file, "w") as f:
        f.write(nb_py[0])

if bee_file.endswith(".py"):
    # TODO: This is a hardcoded module name for this file
    load_bee_file("bee_module", bee_file)
else:
    raise NotImplementedError(f"File format not supported {bee_file}")

from prometheus_client import start_http_server

start_http_server(9000)

swarm = Swarm()
swarm.watch(bee_func[bee_function])
